#include  "msp430g2553.h"


#define     LED                   BIT2  //Ausgang LED steuerung
#define     LED_DIR               P1DIR

void InitializeClocks(void);
volatile long SolarVolt, BattVolt;

int main(void)
{
    WDTCTL = WDTPW | WDTHOLD;   // stop watchdog timer
    LED_DIR |= LED;             //
    P1OUT = 0;                //Initital ausschalten
    InitializeClocks();

    while(1)
      {
        ADC10CTL1 = INCH_0 + ADC10DIV_0;            // A0
        ADC10CTL0 = SREF_1 + ADC10SHT_3 + REFON + ADC10ON;
        __delay_cycles(5);                          // Wait for ADC Ref to settle
        ADC10CTL0 |= ENC + ADC10SC;                 // Sampling and conversion start
        _delay_cycles(100);

        ADC10CTL0 &= ~ENC; ADC10CTL0 &= ~(REFON + ADC10ON);
        SolarVolt = ADC10MEM;
        _delay_cycles(125000);

        ADC10CTL1 = INCH_1 + ADC10DIV_0;            // A1
        ADC10CTL0 = SREF_1 + ADC10SHT_3 + REFON + ADC10ON;
        __delay_cycles(5);                          // Wait for ADC Ref to settle
        ADC10CTL0 |= ENC + ADC10SC;                 // Sampling and conversion start
        _delay_cycles(100);

        ADC10CTL0 &= ~ENC; ADC10CTL0 &= ~(REFON + ADC10ON);
        BattVolt = ADC10MEM;
        _delay_cycles(125000);


        if(SolarVolt >= (BattVolt + 10)) {  //Hell
        //Wenn die Spannung der Batterie 2,8V berschreitet LEDs einschalten um ein berladen zu verhindern
            if(BattVolt >= 974) {
                P1OUT |= LED;     //LED einschalten
            } else {
                P1OUT = 0;
            }
        } else {    //Dunkel
            if (SolarVolt < 400) {
                P1OUT |= LED;     //LED einschalten
            } else {
                P1OUT = 0;
            }
        }
        //LED immer abschalten sobald Spannung kleiner wie 2,1V ist.
        if(BattVolt <= 730) {   //Spannung 1023 = 1,5V ==> 730 = 1,05V (je Zelle)
            P1OUT = 0;
        }

        _delay_cycles(500000);
    }
}



void InitializeClocks(void)
{
  BCSCTL1 = CALBC1_1MHZ;                    // Set range
  DCOCTL = CALDCO_1MHZ;

  BCSCTL3 |= LFXT1S_2;          //LFXT1 = VLO
  IFG1 &= ~OFIFG;                //Clear OSCFault flag
  BCSCTL2 |= SELM_0 + DIVM_3 + DIVS_3;  //MCLK = DCO/8
}
